package java.rmi.dgc;

import java.security.SecureRandom;
import java.rmi.server.UID;
import java.io.Serializable;

public final class VMID implements Serializable
{
    private static final byte[] randomBytes;
    private byte[] addr;
    private UID uid;
    private static final long serialVersionUID = -538642295484486218L;
    
    public VMID() {
        this.addr = VMID.randomBytes;
        this.uid = new UID();
    }
    
    @Deprecated
    public static boolean isUnique() {
        return true;
    }
    
    @Override
    public int hashCode() {
        return this.uid.hashCode();
    }
    
    @Override
    public boolean equals(Object o) {
        if ((o instanceof VMID)) {
            VMID vmid = (VMID)o;
            if (!this.uid.equals(vmid.uid)) {
                return false;
            }
            if ((this.addr == null ^ vmid.addr == null)) {
                return false;
            }
            if (this.addr != null) {
                if (this.addr.length != vmid.addr.length) {
                    return false;
                }
                int i = 0;
                while (i < this.addr.length) {
                    if (this.addr[i] != vmid.addr[i]) {
                        return false;
                    }
                    ++i;
                }
            }
            return true;
        }
        else {
            return false;
        }
    }
    
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer();
        if (this.addr != null) {
            for (int i = 0; i < this.addr.length; ++i) {
                int j = this.addr[i] & 0xFF;
                sb.append(((j < 16) ? "0" : "") + Integer.toString(j, 16));
            }
        }
        sb.append(':');
        sb.append(this.uid.toString());
        return sb.toString();
    }
    
    static {
        SecureRandom secureRandom = new SecureRandom();
        byte[] array = new byte[8];
        secureRandom.nextBytes(array);
        randomBytes = array;
    }
}
